#!/usr/bin/env python
import os, glob

def run(bk):
    # unmanifested files counter
    unmanifested_files = 0

    # print ePub temp folder location
    print('Book temp folder location:', bk._w.ebook_root, '\n')
    
    # get a list of all files in the ePub temp folder
    epub_files = glob.glob(os.path.join(bk._w.ebook_root,  '**', '*.*'), recursive=True)
    
    # check temp folder files against manifest hrefs
    for file_name in epub_files:
    
        # exclude all files in the META-INF folder and content.opf
        if 'META-INF' not in file_name and not file_name.endswith('opf'):
            base_name = os.path.basename(file_name)
            if not bk.basename_to_id(base_name):
                unmanifested_files +=1
                try:
                    os.remove(file_name)
                    print('Unmanifested file', os.path.basename(base_name), 'deleted.\n')
                except:
                    print('Unmanifested file', os.path.basename(base_name), 'couldn\'t be deleted; it\'s most likely locked by another app.\n')

    print('{} unmanifested files(s) found.\n\nClick OK to close the Plugin Runner window.'.format(unmanifested_files))
    return 0

def main():
    print('I reached main when I should not have\n')
    return -1

if __name__ == "__main__":
    sys.exit(main())
